//#include "desc.h"
#include "Door.h"
//#include "List.h"

#define ITEMSIZE 5
#define EXITSIZE 6

class Room
{
public:
//  Room(int);
  void rm(); // room description
  void rmnum(int); // set room number 
  int  retrm(); // return room number
  void setExits(int, int, int, int, int);
  int  getMiscvar(int);
  void setMiscvar(int, int);
  void doFunct(int, char []);
  int  doFunct2(int, char []);
  void doUnlock(int); // probably need to change this or get rid of it
  int retPrevRoom();
  void setPrevRoom(int);

  // inventory functions
  void insertItem(char [], int);
  void removeItem(char []);
  void printItem();
  int  searchItem(char []);

private:
  int roomnum;
  Item rmitems[ITEMSIZE];
  List roominventory; // linked list room inventory;
  int miscvar[ITEMSIZE]; // misc. variables for the rooms
  Door exits[EXITSIZE]; // array for exits
  int prevroom; // room number of previous room
};

void Room :: rm()
{
//  desc(roomnum);
}
// set room number
void Room :: rmnum(int i)
{
  roomnum = i;
}

// return room number
int Room :: retrm()
{
  return roomnum;
}

void Room :: setExits(int door, int lock, int closed, int next_room, int
misc)
{
  exits[door].setDoor(lock, closed, next_room, misc);
}

void Room :: doUnlock(int num)
{
  exits[num].unlockDoor();
}

int Room :: getMiscvar(int arraynum)
{
  return (miscvar[arraynum]);
}

void Room :: setMiscvar(int arraynum, int varnum)
{
  miscvar[arraynum] = varnum;
}


void Room :: doFunct(int num, char functname[])
{
  if (!strcmp(functname, "unlockDoor"))
    exits[num].unlockDoor();
  else if (!strcmp(functname, "openDoor"))
    exits[num].openDoor();
  else if (!strcmp(functname, "closeDoor"))
    exits[num].closeDoor();
  else if (!strcmp(functname, "setMisc"))
    exits[num].setMisc(0);
  else
    cout << "Nothing here for now." << endl;
}

int Room :: doFunct2(int num, char functname[])
{
  int x;

  if (!strcmp(functname, "isLocked"))
    x = exits[num].isLocked();
  else if (!strcmp(functname, "isClosed"))
    x = exits[num].isClosed();
  else if (!strcmp(functname, "getMisc"))
    x = exits[num].getMisc();
  else
    x = -999;

  return x;
}

int Room :: retPrevRoom()
{
  return prevroom;
}

void Room :: setPrevRoom(int oldroom)
{
  prevroom = oldroom;
}

void Room :: insertItem(char itemname[], int num)
{
  roominventory.insert(itemname, num);
}

void Room :: removeItem(char itemname[])
{
  roominventory.remove(itemname);
}

void Room :: printItem()
{
  roominventory.print();
}

int Room :: searchItem(char itemname[])
{
  return roominventory.search(itemname);
}
