/* room18.h - Ruins
 * File created: 22. June 1999 
 * Last modified: 5. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)

void init18(char string[]);
void desc18();
void look18(char []);
void search18(char []);

void room18(Myr & wytch, Room rooms[], int & setroom)
{
  char command[25], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  desc18();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init18(token);
    init18(token2);
    init18(token3);
    init18(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    if (!strcmp(command, "exit game") || !strcmp(command, "quit game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(command, "help"))
      help();
    else if (!strcmp(command, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop); 
    else if (!strcmp(command, "e") || !strcmp(command, "east"))
    {
      strcpy(breakloop, "bye");
      setroom = 19;
    }
    else if (!strcmp(command, "nw") || !strcmp(command, "northwest"))
    {
      cout << "You walk up the trail." << endl;
      rooms[22].setPrevRoom(18);
      setroom = 22;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "u") || !strcmp(token, "up"))
    {
      cout << "You gaze to the sky and see the top of the trees swaying "<<
      endl << "lightly in the post-rain storm winds.  But as much as you"<<
      endl << "may yearn to go up there, you cannot fly." << endl;
    }
    else if (!strcmp(command, "d") || !strcmp(command, "down"))
    {
      if (rooms[18].doFunct2(0, "getMisc") == 0)
      {
        cout << "You move away the rubble and move into the hole in " <<
        endl << "the ground." << endl;
        rooms[7].setPrevRoom(18);
        strcpy(breakloop, "bye");
        setroom = 7;
      }
      else
	cout << "You can't go in that direction. " << endl;
    }
    else if (!strcmp(token, "look"))
      look18(token2);
    else if (!strcmp(token, "search"))
      search18(token2);
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
    {
      if (!strcmp(token2, "rock") || !strcmp(token2, "stone"))
      {
	cout << "You pick up a stone and place it in your pack." << endl;
        wytch.insertInv("stone", 1);
	rooms[18].removeItem("stone");
      }
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 0);
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[0].insertItem(token2, 1);
    }
    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init18(char string[])                                  *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init18(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}

void desc18()
{
  cout <<
  endl << "You are in the ruins of what once was a small village.  " <<
  endl << "Several broken buildings form a half-circle around a large "<<
  endl << "stone ring which once served as a humongous fire pit.  You "<<
  endl << "see a faint path leading up to the northwest and a more well"<<
  endl << "worn path leading to the east towards the coast." << endl;
}

void look18(char token2[])
{
  if (!strcmp(token2, "building") || !strcmp(token2, "buildings"))
  { 
    cout << "The buildings have been worn down to rubble over the " <<
    endl << "ages of time." << endl;
  }
  else if (!strcmp(token2, "rubble"))
  {
    cout << "Beneath one pile of loose shale and rubble you see a " <<
    endl << "hole going into the ground. " << endl;
  }
  else if (!strcmp(token2, "hole"))
  {
    cout << "You feel a very faint and dry breeze coming from the hole. "
    << endl << "However, you can't see anything in the hole, it's too " <<
    endl << "dark to see inside there." << endl;
  }
  else if (!strcmp(token2, "ground") || !strcmp(token2, "floor"))
  {
    cout <<"You see a lot of loose stones and shale scattered on the ground."<<
    endl;
  }
  else if (!strcmp(token2, "pit") || !strcmp(token2, "fire"))
  {
    cout << "You see a ring of large stones which once made up a huge fire" <<
    endl << "pit in the center of the ruined village." << endl;
  }
  else
    desc18();
}

void search18(char token2[])
{
  if (!strcmp(token2, "rubble") || !strcmp(token2, "ruins") || !strcmp(token2, "buildings"))
  {
    cout << "You search among the strewn rocks and don't find much except for many stones." << endl;
  }
  else if (!strcmp(token2, "fire") || !strcmp(token2, "pit"))
  {
    cout << "You scrounge through the ancient fire pit, but don't find anything of use." << endl;
  }  
  else
    cout << "What are you searching for?" << endl;

}
