/* tutorial.h
 * Created: June 1999
 * Last modified: 4. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // included for exit(1) function
#include <termios.h>
#include <unistd.h>

#define STDIN   0
#define STDOUT  1

void cont();
int  getch();
void goal();
void play();
void sandi();
void interacting();
void saveandrestore();
void casting();
void tips();
void spells_tutorial();
void sospells();
void elspells();
void psspells();
void spspells();

void tutorial()
{
  int  choice = 0;

  do
  {

  cout <<
  endl << "Psychomancer Tutorial" <<
  endl << "---------------------" <<
  endl << "1. Overview & Goal " << 
  endl << "2. General Game Play" <<
  endl << "3. Spells" <<
  endl << "4. Play Game" <<
  endl << "5. Quit" <<
  endl << "---------------------" <<
  endl << "> ";

//  cin >> choice;
  get_int(choice, 1, 5);
  cout << endl;

  switch(choice)
  {
  case 1 : goal(); break;
  case 2 : play(); break;
  case 3 : spells_tutorial(); break;
  case 4 : break;
  case 5 : cout << "Good bye." << endl; exit(1); break;
  default : cout << "That wasn't an appropriate choice." << endl;
  }

  }
  while (choice < 4);
}

void cont()
{
  char ch = '\0';

  cout << "Press a key to continue..." << endl;
  ch = getch();
}

/*
 * getch() used to stop the screen until the user types in a character to 
 * continue
 */
int getch(void)
{
        struct termios old_termios;
        struct termios new_termios;
        char ch;

        /* save current terminal settings */
        tcgetattr(STDOUT, &old_termios);

        /* set to non canonical mode, echo off, ignore signals */
        new_termios = old_termios;
        new_termios.c_lflag &= ~(ECHO | ICANON | ISIG | IEXTEN);
        new_termios.c_cc[VMIN] = 1;
        new_termios.c_cc[VTIME] = 0;

        tcsetattr(STDOUT, TCSAFLUSH, &new_termios);
        
        read(STDIN, &ch, 1);

        /* restore old terminal settings */
        tcsetattr(STDOUT, TCSAFLUSH, &old_termios);

        return ch;
}

void goal()
{
  cout <<
  endl << "OVERVIEW & GOAL" <<
  endl << "---------------" << endl << endl;

  cout << "OVERVIEW:" <<
  endl << "Psychomancer is a text-based Role Playing Game (RPG)" << 
  endl << "and adventure game.  You play as the main character " <<
  endl << "who can do many common actions such as picking up objects "<<
  endl << "looking at things, walking around, and even getting hurt." <<
  endl << "By using a combination of imagination and strategy, you " <<
  endl << "can successfully get your character through a series of " <<
  endl << "puzzles and obstacles." << endl << endl;

  cout << "GOAL:" <<
  endl << "Your primary goal is to get your character, a spell-" <<
  endl << "casting wytch out of the dungeon she is trapped in at " <<
  endl << "the beginning of the game (how rare...a dungeon in a " <<
  endl << "fantasy game) and get her off the island." << endl << endl;

  cont();
}

void play()
{
  int choice = 0;

  cout << "GENERAL GAME PLAY" << 
  endl << "------------------------------" << 
  endl << "1. Statistics & Inventory" <<
  endl << "2. Interacting with the game" <<
  endl << "3. Saving & Restoring the game" <<
  endl << "4. Casting spells" <<
  endl << "5. Tips" << 
  endl << "------------------------------" <<
  endl << "> ";
  get_int(choice, 1, 5);

  switch(choice)
  {
    case 1 : sandi(); break;
    case 2 : interacting(); break;
    case 3 : saveandrestore(); break;
    case 4 : casting(); break;
    case 5 : tips(); break;
    default : cout << "That was not a choice." << endl;
  }
}

void sandi()
{
  cout <<
  endl << "STATISTICS & INVENTORY" <<
  endl << "----------------------" <<
  endl << "The statistics menu displays the Life Points (LP), the Essence"<<
  endl << "Points(EP), and the spells the character knows.  The Life Points"<<
  endl << "displays the amount of health the character has.  If the LP"<<
  endl << "drop to 0 or below, then the character is dead and the game" <<
  endl << "is over.  Essence Points tell how much energy the wytch has" <<
  endl << "to cast spells.  If the EP drop to 0 or below, then the wytch"<<
  endl << "can no longer cast spells until more Essence Points are gained."<<
  endl << "The spells list will show which spells the character knows," <<
  endl << "and the number of EP the spell will cost is in parenthese" <<
  endl << "after the spell name.  To bring up the statistics menu during"<<
  endl << "the game, type the word 'stats'." << endl << endl;

  cont();

  cout <<
  endl << "The inventory is the list for what the character is holding" <<
  endl << "in her possession.  To bring up the inventory, type either " <<
  endl << "the letter 'i' or type 'inventory'.  To pick up an item, type "<<
  endl << "'get' or 'take' and then the item's name (i.e. get stone)."<<
  endl << "To drop an item, just type 'drop' and the item's name. (i.e. "<<
  endl << "drop stone)" << endl << endl;
}

void interacting()
{
  int choice = 0;

  cout <<
  endl << "INTERACTING" <<
  endl << "-----------" <<
  endl << "1. Looking" <<
  endl << "2. Quitting the game" <<
  endl << "3. Moving" <<
  endl << "4. Basic functions" <<
  endl << "> ";
  get_int(choice, 1, 4);

  if (choice == 1)
  {
    cout << 
    endl << "LOOKING" <<
    endl << "-------" <<
    endl << "To get a general idea of what your surroundings are, " <<
    endl << "type 'look'.  To inspect an object in the room more closely,"<<
    endl << "type 'look' and the object's name (i.e. look ground)."<<endl;
  }
  else if (choice == 2)
  {
    cout << 
    endl << "QUITTING THE GAME" <<
    endl << "-----------------" <<
    endl << "If at any time you wish to quit the game, simply type" <<
    endl << "'quit' or 'quit game' at the parser ( > )." << endl;
  }
  else if (choice == 3)
  {
    cout <<
    endl << "MOVING" <<
    endl << "------" <<
    endl << "You will often have several directions you can move in "<<
    endl << "the various rooms of the game.  Generally just by looking"<<
    endl << "around you will know which ways you can move.  If you try"<<
    endl << "to move in a direction you can't go, you will be told." <<
    endl << "To move type directions (north, east, south, west, up, down)"<<
    endl << "or use their abbreviations (n, e, s, w, u, d)." << endl;
  }
  else
  {
    cout <<
    endl << "BASIC FUNCTIONS" <<
    endl << "---------------" <<
    endl << "There are many other various actions you will need to " <<
    endl << "perform such as taking items, opening and closing doors,"<<
    endl << "drinking a potion, and so on.  Many commands are fairly" <<
    endl << "simple like 'open', 'close', 'get', 'drink', etc..." <<
    endl << "For more help, type 'help' during the game." << endl;
  }
}

void saveandrestore()
{
  cout <<
  endl << "SAVING AND RESTORING THE GAME" <<
  endl << "-----------------------------" <<
  endl << "To save a game so you don't have to restart the game from" <<
  endl << "the beginning each time, type the word 'save' or 'save game'"<<
  endl << "during the game and then give the saved game a name." << endl<<
  endl << "There are two ways to restore a saved game - either from the"<<
  endl << "beginning of the game, or by typing in 'restore' or 'restore"<<
  endl << "game' during the game.  Then type in the name of the saved" <<
  endl << "game to restore to your last place." << endl << endl;
}

void casting()
{
  cout <<
  endl << "CASTING SPELLS" <<
  endl << "--------------" <<
  endl << "To cast a spell type 'cast' and the name of the spell." <<
  endl << "To find out what spells you have, type 'stats' and the" <<
  endl << "statistics menu will give you a listing of what spells" <<
  endl << "you know, and how many Essence Points each spell will" <<
  endl << "cost in parenthese.  Becareful to type the spell's name" << 
  endl << "in correctly or else the spell won't work." << endl << endl;
}

void tips()
{
  cout <<
  endl << "TIPS" <<
  endl << "----" <<
  endl << "Remember to save often, ususally every 5 to 10 minutes, "<<
  endl << "so if you do have an unexpected occurrence (such as the" <<
  endl << "character dying or your computer being flattened by a 16"<<
  endl << "ton weight), you won't have to restart from the very beginning"<<
  endl << "again.  If you are having trouble, try looking through the " <<
  endl << "tutorial some more or type 'help' during the game." << endl << 
  endl << "Also remember to look at EVERYTHING.  Some items might give"<<
  endl << "clues on what to do next, or where to go.  If you are truly"<<
  endl << "stuck, try playing again, except this time with a different"<<
  endl << "Spell Circle (Sorcery, Elementalism, Psychomancy, Spirit)." <<
  endl << "Some puzzles might be easier to solve with a different " <<
  endl << "character, depending on each character's spells and resources."<<
  endl << endl;

  cont();
}

void spells_tutorial()
{
  int choice1 = 0;

  cout << "SPELLS" <<
  endl << "------" << endl <<
  endl << "Spells are the tools the wytch uses to aid her during her" <<
  endl << "quest.  There are four Circles of Magic: Sorcery, Elementalism"<<
  endl << "Psychomancy, and Spirit.  Each Circle has its own set of " <<
  endl << "spells, though some of the spells are so common-place that " <<
  endl << "a wytch from any Circle can cast it.  Any general spell will"<<
  endl << "have the word [General] before its description to indicate" <<
  endl << "that this spell can be cast by anyone.  Casting spells drain"<<
  endl << "the wytch's Essence Points, and after each spell name is the"<<
  endl << "number of EP it costs to cast that particular spell." << endl<<
  endl << "1. Sorcerer's Spells" <<
  endl << "2. Elementalist's Spells" <<
  endl << "3. Psychomancer's Spells" <<
  endl << "4. Spirit Mage's Spells" <<
  endl << "5. Go back to the Tutorial" <<
  endl << endl << "Choose which set of spells you want to read > ";
 
  get_int(choice1);

  switch(choice1)
  {
  case 1: sospells(); break;
  case 2: elspells(); break;
  case 3: psspells(); break;
  case 4: spspells(); break;
  case 5: break;
  default: cout << "That wasn't an available choice." << endl;
  }  

}

void sospells()
{
  cout <<
  endl << "SORCERER'S SPELLS" <<
  endl << "-----------------" <<
  endl << "The sorcerer has the broadest base of spells to choose from" <<
  endl << "and isn't as specialized as the other three Circles of Magic."<<
  endl <<
  endl << "AURA (2) - An aura is cast upon a weapon to increase the damage"<<
  endl << "to teh attack.  For each successful strike, an extra Essence "<<
  endl << "Point is used.  The spell fades away after combat or when all"<<
  endl << "Essence Points have been used up.  This spell can't be cast"<<
  endl << "when the person is unarmed." << endl <<
  endl << "ILLUMINATE (2) [General] - creates a small floating ball of "<< 
  endl << "heatless light.  If cast upon an object, such as a staff, it "<< 
  endl << "causes the object to then glow." << endl <<
  endl << "UNLOCK (2) - can unlock and undo simple mechanisms such as "<<
          "locks and knots." << endl <<
  endl << "TRANSLATE (4) - allows the caster to understand foreign " <<
          "languages." << endl <<
  endl << "ACID BURN (5) - offensive combat spell which sprays a " <<
  endl << "magical burst of acid at your enemy.  The spell does continual"<<
  endl << "damage during combat while the acid eats away." << endl << endl;

  cont();
}

void elspells()
{
  cout <<
  endl << "ELEMENTALIST'S SPELLS" <<
  endl << "---------------------" <<
  endl << "The Elementalist's spells work primarily with those of the"<<
  endl << "four Elements: Fire, Earth, Water, and Air.  The spells' " <<
  endl << "abilities can be limiting at times, but they are often great"<<
  endl << "during a time of combat." << endl <<
  endl << "ELEMENT TALK (5) - allows the Elementalist to communicate" <<
  endl << "with the Elements, and even ask for aid.  However, this spell"<<
  endl << "cannot control the Elements.  This spell might require more" <<
  endl << "Essence Points thant the inital 5 EP if communicating is "
       << "difficult." << endl <<
  endl << "ELIXER (6) - with this spell the Elementalist is able to turn" <<
  endl << "a flask of boiling water into an Elixer which will restore " <<
  endl << "eight Life Points when drunk.  Note that the water has to be" <<
  endl << "boiling or else the spell won't work." << endl <<
  endl << "FIRE SPEAR (7) - a lance of flame is extended from the caster's"<<
  endl << "hand, impaling anything in its path.  This is often useful in"<< 
  endl << "attacking several enemies at the same time.  The damage increases"<<
  endl << "with the caster's skill and experience." << endl <<
  endl << "FIRE WIND (25)  - A sheet of fire is directed towards a target"<<
  endl << "to be set ablaze.  However, due to its ferocity, it costs" <<
  endl << "25 Essence Points" << endl << endl;

  cont();
}

void psspells()
{
  cout <<
  endl << "PSYCHOMANCER'S SPELLS" <<
  endl << "---------------------" <<
  endl << "The Psychomancer molds Essence with the force of her mind" <<
  endl << "to achieve her goals." << endl <<
  endl << "SENSE (3) [General] - A detection spell which reveals the " <<
  endl << "nature of a person, creature, or area." << endl <<
  endl << "MENTAL KEY (4) - A more powerful version of Sorcery's Unlock"<<
  endl << "spell, specialized for the Psychomancer." << endl <<
  endl << "HISTORY (5) - An advanced form of the Sense spell which can "<<
  endl << "also reveal the past occurrences of people, places or "
       << "things." << endl <<
  endl << "PSYCHIC BLOCK (4) - this spell raises a shield to help reduce"<<
  endl << "some of the impact caused from a psychic blast and other " <<
  endl << "Psychomancer-related attack spells." << endl <<
  endl << "PSYCHIC BLAST (6) - a concentrated shock of psychic energy" <<
  endl << "is shot at an opponent to cause damage.  Can be deflected by"<<
  endl << "a Psychic Block." << endl << endl;

  cont();
}

void spspells()
{
  cout <<
  endl << "SPIRIT MAGE'S SPELLS" <<
  endl << "---------------------" <<
  endl << "Spirit is the darkest of the four Circles, often using the " <<
  endl << "energy of other planes of existence for the mage's use." <<
  endl <<
  endl << "CREATE BLOODSTONE (3) [General] - imbues a small rock with " <<
  endl << "the latent energy necessary to perform rituals and designing"<<
  endl << "a Magic Circle.  A kris (a ceremonial knife) can be often" << 
  endl << "used instead of a BloodStone." << endl <<
  endl << "DRAIN (7) - draws the strength and Life from a living creature."<<
  endl << "For every 10 Life Points drained, the Spirit Mage gains 1 Life"<<
  endl << "Point." << endl <<
  endl << "SPIRIT TALK (10) - Dealing with the Dead is always a risky" <<
  endl << "and draining task for a Spirit Mage.  When trying to speak" <<
  endl << "with the Dead, the Spirit Mage should be protected by standing"<<
  endl << "inside a Magic Circle.  A bloodStone or kris is needed to " <<
  endl << "create a Magic Circle." << endl << endl;

  cont();
}
